/**************************************************************
  (C) 1997 by Achim Kaiser

  You may distribute under the terms of the GNU General Public
  License as specified in the COPYING file.
**************************************************************/

#include "iconmanager.h"
#include "filemanager.h"
#include <unistd.h>
#include "iwc.h"
#include "shell.h"
#include "extension.h"
#include "color.h"
#include "pixmap.h"
#include "positiontext.h"
#include "windowname.h"
#include "global.h"
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <stdlib.h>
#include "menus.h"
#include "timer.h"
#include "makeicon.h"
#include <Xlib.h>
#include <Xutil.h>
#include "includepixmaps/quader.xpm"
#include "includepixmaps/moveymaintop.xpm"
#include "includepixmaps/moveymainmiddle.xpm"
#include "includepixmaps/moveymainbottom.xpm"
#include "includepixmaps/moveytop.xpm"
#include "includepixmaps/moveymiddle.xpm"
#include "includepixmaps/moveybottom.xpm"
#include "includepixmaps/movexmainleft.xpm"
#include "includepixmaps/movexmainmiddle.xpm"
#include "includepixmaps/movexmainright.xpm"
#include "includepixmaps/movexleft.xpm"
#include "includepixmaps/movexmiddle.xpm"
#include "includepixmaps/movexright.xpm"
#include "includepixmaps/treeplus.xpm"
#include "includepixmaps/treeminus.xpm"
      
#include <extensions/shape.h>

struct item *directory=NULL;
struct tree *toptree=NULL;

struct item **itemarray=NULL;
int anzahlarray=0;
int *oldx=NULL;
int *oldy=NULL;
int savex=5;
int savey=5;
int maxheight=0;

int maindesktoparrangetype=0;
int mainax=5;
int mainay=5;
int mainbx=5;
int mainby=5;

int grid=0;

Window movexmain,movex;
Window moveymain,movey;
Window quader;
int moveonx=False,moveony=False;
int quaderon=False;

int sorttype;

Pixmap opened=0;
Pixmap opened_shape=0;
Pixmap closed=0;
Pixmap closed_shape=0;

Window Freeze(int doit)
{
  static Window freezewin=0;
  int x,y;
  unsigned int width,height;
  unsigned int border,depth;
  Window root;
  if (doit==True) {
  XGetGeometry(GetDisplay(),GetWindow(),&root,&x,&y,
	       &width,&height,&border,&depth);
  freezewin=XCreateSimpleWindow(GetDisplay(),GetWindow(),0,0,width,height,0,0,0);
  XSetWindowBackgroundPixmap(GetDisplay(),freezewin,0);
  XMapRaised(GetDisplay(),freezewin);
  } else if (doit==False) {
    if (freezewin!=0)
      XDestroyWindow(GetDisplay(),freezewin);
    freezewin=0;
  }
  return freezewin;
}

void CalcMoveWindowSize()
{
  unsigned int minx,miny;
  int ax,ay;
  int x,y;
  int i;
  unsigned int width,height;
  unsigned int border,depth;
  Window root;
  struct item *direntry;
  Pixmap pixelmap,pixelmap2;
  GC gc;
  unsigned int dummy;
  if (GetIsDesktop()==False) {
    XGetGeometry(GetDisplay(),GetMoveWindow(),&root,&ax,&ay,
		 &width,&height,&border,&depth);
    minx=0;
    miny=0;
    direntry=directory;
    
    while (direntry!=NULL) {
      XGetGeometry(GetDisplay(),direntry->Iconwindow,&root,&x,&y,
		   &width,&height,&border,&depth);
      if (minx<x+width) minx=x+width;
      if (miny<y+height) miny=y+height;
      direntry=direntry->NextItem;
    }
    for (i=0;i<3;i++) {
      XGetGeometry(GetDisplay(),GetWindow(),&root,&x,&y,
		   &width,&height,&border,&depth);
      if (moveony==True) width=width-14;
      if (moveonx==True) height=height-14;
      if (miny>height|| ay!=0) { 
	if (moveony==False) {
	  moveymain=XCreateSimpleWindow(GetDisplay(),GetWindow(),
					width,0,14,height,0,
					0,0);
	  XSelectInput(GetDisplay(),moveymain,ButtonReleaseMask|ButtonPressMask
		       |PointerMotionMask);
	  movey=XCreateSimpleWindow(GetDisplay(),moveymain,
				    2,2,14,height-4,0,
				    0,0);
	  XSelectInput(GetDisplay(),movey,ButtonReleaseMask|ButtonPressMask
		       |PointerMotionMask);
          XLowerWindow(GetDisplay(),moveymain);
          XMapWindow(GetDisplay(),moveymain);
          XMapRaised(GetDisplay(),movey);
	  moveony=True;
	}
	XMoveResizeWindow(GetDisplay(),moveymain,width,0,14,height);
      } else {
	if (moveony==True) {
	  XDestroyWindow(GetDisplay(),moveymain);
	  moveony=False;
	}      
      }
      if (minx>width || ax!=0 ) { 
	if (moveonx==False) {
	  movexmain=XCreateSimpleWindow(GetDisplay(),GetWindow(),
					0,height,width,14,0,
					0,0
					);
	  XSelectInput(GetDisplay(),movexmain,ButtonReleaseMask|ButtonPressMask
		       |PointerMotionMask);
	  movex=XCreateSimpleWindow(GetDisplay(),movexmain,
				    0,0,width-4,14,0,
				    0,0);
	  XSelectInput(GetDisplay(),movex,ButtonReleaseMask|ButtonPressMask
		       |PointerMotionMask);
          XLowerWindow(GetDisplay(),movexmain);
          XMapWindow(GetDisplay(),movexmain);
          XMapRaised(GetDisplay(),movex);
	  moveonx=True;
	}
	XMoveResizeWindow(GetDisplay(),movexmain,0,height,width,14);
      } else {
	if (moveonx==True) {
	  XDestroyWindow(GetDisplay(),movexmain);
	  moveonx=False;
	}
      }
    }
    if (moveonx==True || moveony==True) {
      if (quaderon==False) {
	quader=XCreateSimpleWindow(GetDisplay(),GetWindow(),
				   width,height,14,14,0,0,0);
	XSelectInput(GetDisplay(),quader,ButtonReleaseMask|ButtonPressMask
		     |PointerMotionMask);
	DataPixmap(quader_xpm,&pixelmap,NULL);
	XSetWindowBackgroundPixmap(GetDisplay(),quader,pixelmap);
	XFreePixmap(GetDisplay(),pixelmap);
	XMapRaised(GetDisplay(),quader);
	quaderon=True;
      }
      XMoveResizeWindow(GetDisplay(),quader,width,height,14,14);
    } else {
      if (quaderon==True) {
	XDestroyWindow(GetDisplay(),quader);
	quaderon=False;
      }
    }
    if (width-ax>minx) minx=width-ax;
    if (height-ay>miny) miny=height-ay;
    XResizeWindow(GetDisplay(),GetMoveWindow(),minx,miny);
    if (moveony==True) {
      XMoveResizeWindow(GetDisplay(),movey,
			2,
			2+(int)((double)(height-4)*(double)(-ay)/(double)miny),
			10,
			1+(int)((double)(height-4)*(double)height/(double)miny)
			);
    }
    if (moveonx==True) {
      XMoveResizeWindow(GetDisplay(),movex,
			2+(int)((double)(width-4)*(double)(-ax)/(double)minx),
			2,
			1+(int)((double)(width-4)*(double)width
				/(double)minx),
			10
			);
    }
    if (moveony==True) {
      gc=XCreateGC(GetDisplay(),XDefaultRootWindow(GetDisplay()),0,0);
      XGetGeometry(GetDisplay(),moveymain,&root,&x,&y,&width,&height,&dummy,&depth);
      pixelmap=XCreatePixmap(GetDisplay(),moveymain,width,height,depth);
      /*top*/
      DataPixmap(moveymaintop_xpm,&pixelmap2,NULL);
      XCopyArea(GetDisplay(),pixelmap2,pixelmap,gc,0,0,14,3,0,0);
      XFreePixmap(GetDisplay(),pixelmap2);
      /*middle*/
      DataPixmap(moveymainmiddle_xpm,&pixelmap2,NULL);
      for (i=3;i<height;i=i+14)
	XCopyArea(GetDisplay(),pixelmap2,pixelmap,gc,0,0,14,14,0,i);
      XFreePixmap(GetDisplay(),pixelmap2);
      /*bottom*/
      DataPixmap(moveymainbottom_xpm,&pixelmap2,NULL);
      XCopyArea(GetDisplay(),pixelmap2,pixelmap,gc,0,0,14,3,0,height-3);
      XFreePixmap(GetDisplay(),pixelmap2);

      XSetWindowBackgroundPixmap(GetDisplay(),moveymain,pixelmap);
      XFreePixmap(GetDisplay(),pixelmap);
      /*slider*/
      XGetGeometry(GetDisplay(),movey,&root,&x,&y,&width,&height,&dummy,&depth);
      pixelmap=XCreatePixmap(GetDisplay(),movey,width,height,depth);
      /*top*/
      DataPixmap(moveytop_xpm,&pixelmap2,NULL);
      XCopyArea(GetDisplay(),pixelmap2,pixelmap,gc,0,0,10,3,0,0);
      XFreePixmap(GetDisplay(),pixelmap2);
      /*middle*/
      DataPixmap(moveymiddle_xpm,&pixelmap2,NULL);
      for (i=3;i<height;i=i+10)
	XCopyArea(GetDisplay(),pixelmap2,pixelmap,gc,0,0,10,10,0,i);
      XFreePixmap(GetDisplay(),pixelmap2);
      /*bottom*/
      DataPixmap(moveybottom_xpm,&pixelmap2,NULL);
      XCopyArea(GetDisplay(),pixelmap2,pixelmap,gc,0,0,10,3,0,height-3);
      XFreePixmap(GetDisplay(),pixelmap2);

      XSetWindowBackgroundPixmap(GetDisplay(),movey,pixelmap);
      XFreePixmap(GetDisplay(),pixelmap);
      XFreeGC(GetDisplay(),gc);
      XClearWindow(GetDisplay(),moveymain);
      XClearWindow(GetDisplay(),movey);
      if (Freeze(2)==0)
        XRaiseWindow(GetDisplay(),moveymain);
    }
    if (moveonx==True) {
      gc=XCreateGC(GetDisplay(),XDefaultRootWindow(GetDisplay()),0,0);
      XGetGeometry(GetDisplay(),movexmain,&root,&x,&y,&width,&height,&dummy,&depth);
      pixelmap=XCreatePixmap(GetDisplay(),movexmain,width,height,depth);
      /*top*/
      DataPixmap(movexmainleft_xpm,&pixelmap2,NULL);
      XCopyArea(GetDisplay(),pixelmap2,pixelmap,gc,0,0,3,14,0,0);
      XFreePixmap(GetDisplay(),pixelmap2);
      /*middle*/
      DataPixmap(movexmainmiddle_xpm,&pixelmap2,NULL);
      for (i=3;i<width;i=i+14)
	XCopyArea(GetDisplay(),pixelmap2,pixelmap,gc,0,0,14,14,i,0);
      XFreePixmap(GetDisplay(),pixelmap2);
      /*bottom*/
      DataPixmap(movexmainright_xpm,&pixelmap2,NULL);
      XCopyArea(GetDisplay(),pixelmap2,pixelmap,gc,0,0,3,14,width-3,0);
      XFreePixmap(GetDisplay(),pixelmap2);

      XSetWindowBackgroundPixmap(GetDisplay(),movexmain,pixelmap);
      XFreePixmap(GetDisplay(),pixelmap);
      /*slider*/
      XGetGeometry(GetDisplay(),movex,&root,&x,&y,&width,&height,&dummy,&depth);
      pixelmap=XCreatePixmap(GetDisplay(),movex,width,height,depth);
      /*top*/
      DataPixmap(movexleft_xpm,&pixelmap2,NULL);
      XCopyArea(GetDisplay(),pixelmap2,pixelmap,gc,0,0,3,10,0,0);
      XFreePixmap(GetDisplay(),pixelmap2);
      /*middle*/
      DataPixmap(movexmiddle_xpm,&pixelmap2,NULL);
      for (i=3;i<width;i=i+10)
	XCopyArea(GetDisplay(),pixelmap2,pixelmap,gc,0,0,10,10,i,0);
      XFreePixmap(GetDisplay(),pixelmap2);
      /*bottom*/
      DataPixmap(movexright_xpm,&pixelmap2,NULL);
      XCopyArea(GetDisplay(),pixelmap2,pixelmap,gc,0,0,3,10,width-3,0);
      XFreePixmap(GetDisplay(),pixelmap2);

      XSetWindowBackgroundPixmap(GetDisplay(),movex,pixelmap);
      XFreePixmap(GetDisplay(),pixelmap);
      XFreeGC(GetDisplay(),gc);
      XClearWindow(GetDisplay(),movexmain);
      XClearWindow(GetDisplay(),movex);
      if (Freeze(2)==0)
        XRaiseWindow(GetDisplay(),movexmain);
    }
  }
}

void ResetPosition()
{
  XWindowAttributes attr;
  char *position,*b,*c;
  if (GetIsDesktop()==True) {
    XGetWindowAttributes(GetDisplay(),GetMoveWindow(),&attr);
    GetFileInfoFromDesktop(GetWindowName(),&position,&b,&c);
    GetPositionFromText(position,&mainax,&mainay,NULL);
    GetPositionFromText(c,&mainbx,&mainby,NULL);
    if (position[0]=='a') {
      maindesktoparrangetype=1;
      savex=mainax;
      savey=mainay;      
    } else if (position[0]=='b') {
      maindesktoparrangetype=2;
      savex=mainax;
      savey=attr.height-mainby;      
    } else if (position[0]=='c') {
      maindesktoparrangetype=3;
      savex=attr.width-mainbx;      
      savey=mainay;
    } else {
      maindesktoparrangetype=0;
      savex=mainax;
      savey=mainay;
    }
    free(position);free(b);free(c);
  } else { 
    savex=5;
    if (GetKindOfWindow()==STRUCTURE)
      savey=0;
    else
      savey=5;
  }
  maxheight=0;
  anzahlarray=0;
}

void SetBestPosition(struct item *direntry,int sx,int sy)
{
  XWindowAttributes attr;
  int x,y,i;
  char *text,*text2;
  char *pos,*a,*b,*c;
  text=malloc(strlen(direntry->filename)+strlen(GetPath())+1);
  strcpy(text,GetPath());
  strcat(text,direntry->filename);
  GetFileInfoFromDesktop(text,&a,&b,&c);
  if (a==NULL || a[0]!='a' || GetKindOfWindow()!=NORMAL) {
    XGetWindowAttributes(GetDisplay(),GetMoveWindow(),&attr);
    if (GetKindOfWindow()==NORMAL) {
      if (GetIsDesktop()==True) {
	if (maindesktoparrangetype==0) {
	anzahlarray++;
	itemarray=realloc(itemarray,sizeof(struct item *) * anzahlarray);
	oldx=realloc(oldx,sizeof(int) * anzahlarray);
	oldy=realloc(oldy,sizeof(int) * anzahlarray);
	if (savex+sx+14 > attr.width-mainbx && savex != mainax) {
	  savex=5;
	  savey=savey+maxheight+10;
	  maxheight=0;
	  anzahlarray=1;
	  itemarray=realloc(itemarray,sizeof(struct item *));
	  oldx=realloc(oldx,sizeof(int));
	  oldy=realloc(oldy,sizeof(int));
	}
	if (sy>maxheight) {
	  for (i=0;i<anzahlarray-1;i++) {
	    oldy[i]=oldy[i]+sy-maxheight;
	    XMoveWindow(GetDisplay(),itemarray[i]->Iconwindow,oldx[i],oldy[i]);
	    text2=malloc(strlen(itemarray[i]->filename)+strlen(GetPath())+1);
	    strcpy(text2,GetPath());
	    strcat(text2,itemarray[i]->filename);
	    SetPositionToText(&pos,oldx[i],oldy[i],' ');
	    SendFileInfoToDesktop(text2,pos,NULL,NULL);
	    free(pos);
	    free(text2);
	  }
	  maxheight=sy;
	}
	x=savex;
	y=savey+maxheight-sy;
	savex=savex+sx+10;
	itemarray[anzahlarray-1]=direntry;
	oldx[anzahlarray-1]=x;
	oldy[anzahlarray-1]=y;
        /**********************alt
	  if (savex+sx+14 > attr.width-mainbx && savex != mainax) {
	    savex=mainax;
	    savey=savey+maxheight+10;
	    maxheight=0;
	  }
	  if (sy>maxheight)
	    maxheight=sy;
	  x=savex;
	  y=savey;
	  savex=savex+sx+10;
	alt ******************/
	} else if (maindesktoparrangetype==2) {
	  if (savex+sx+14 > attr.width-mainbx && savex != mainax) {
	    savex=mainax;
	    savey=savey-maxheight-10;
	    maxheight=0;
	  }
	  if (sy>maxheight)
	    maxheight=sy;
	  x=savex;
	  y=savey-sy;
	  savex=savex+sx+10;
	} else if (maindesktoparrangetype==1) {
	  anzahlarray++;
	  itemarray=realloc(itemarray,sizeof(struct item *) * anzahlarray);
	  oldx=realloc(oldx,sizeof(int) * anzahlarray);
	  oldy=realloc(oldy,sizeof(int) * anzahlarray);
	  if (savey+sy+14 > attr.height-mainby && savey != mainay) {
	    savey=mainay;
	    savex=savex+maxheight+10;
	    maxheight=0;
	    anzahlarray=1;
	    itemarray=realloc(itemarray,sizeof(struct item *));
	    oldx=realloc(oldx,sizeof(int));
	    oldy=realloc(oldy,sizeof(int));
	  }
	  if (sx>maxheight) {
	    for (i=0;i<anzahlarray-1;i++) {
	      oldx[i]=oldx[i]+(sx-maxheight)/2;
	      XMoveWindow(GetDisplay(),itemarray[i]->Iconwindow,oldx[i],oldy[i]);
	      text2=malloc(strlen(itemarray[i]->filename)+strlen(GetPath())+1);
	      strcpy(text2,GetPath());
	      strcat(text2,itemarray[i]->filename);
	      SetPositionToText(&pos,oldx[i],oldy[i],' ');
	      SendFileInfoToDesktop(text2,pos,NULL,NULL);
	      free(pos);
	      free(text2);
	    }
	    maxheight=sx;
	  }
	  x=savex+(maxheight-sx)/2;
	  y=savey;
	  savey=savey+sy+10;
	  itemarray[anzahlarray-1]=direntry;
	  oldx[anzahlarray-1]=x;
	  oldy[anzahlarray-1]=y;
	} else {
	  /*************/
	  anzahlarray++;
	  itemarray=realloc(itemarray,sizeof(struct item *) * anzahlarray);
	  oldx=realloc(oldx,sizeof(int) * anzahlarray);
	  oldy=realloc(oldy,sizeof(int) * anzahlarray);
	  if (savey+sy+14 > attr.height-mainby && savey != mainay) {
	    savey=mainay;
	    savex=savex-maxheight-10;
	    maxheight=0;
	    anzahlarray=1;
	    itemarray=realloc(itemarray,sizeof(struct item *));
	    oldx=realloc(oldx,sizeof(int));
	    oldy=realloc(oldy,sizeof(int));
	  }
	  if (sx>maxheight) {
	    for (i=0;i<anzahlarray-1;i++) {
	      oldx[i]=oldx[i]-(sx-maxheight)/2;
	      XMoveWindow(GetDisplay(),itemarray[i]->Iconwindow,oldx[i],oldy[i]);
	      text2=malloc(strlen(itemarray[i]->filename)+strlen(GetPath())+1);
	      strcpy(text2,GetPath());
	      strcat(text2,itemarray[i]->filename);
	      SetPositionToText(&pos,oldx[i],oldy[i],' ');
	      SendFileInfoToDesktop(text2,pos,NULL,NULL);
	      free(pos);
	      free(text2);
	    }
	    maxheight=sx;
	  }
	  x=savex-sx-(maxheight-sx)/2;
	  y=savey;
	  savey=savey+sy+10;
	  itemarray[anzahlarray-1]=direntry;
	  oldx[anzahlarray-1]=x;
	  oldy[anzahlarray-1]=y;
	  /*************/
	}
	  
      } else {
	anzahlarray++;
	itemarray=realloc(itemarray,sizeof(struct item *) * anzahlarray);
	oldx=realloc(oldx,sizeof(int) * anzahlarray);
	oldy=realloc(oldy,sizeof(int) * anzahlarray);
	if (savex+sx+14 > attr.width && savex != 5) {
	  savex=5;
	  savey=savey+maxheight+10;
	  maxheight=0;
	  anzahlarray=1;
	  itemarray=realloc(itemarray,sizeof(struct item *));
	  oldx=realloc(oldx,sizeof(int));
	  oldy=realloc(oldy,sizeof(int));
	}
	if (sy>maxheight) {
	  for (i=0;i<anzahlarray-1;i++) {
	    oldy[i]=oldy[i]+sy-maxheight;
	    XMoveWindow(GetDisplay(),itemarray[i]->Iconwindow,oldx[i],oldy[i]);
	    text2=malloc(strlen(itemarray[i]->filename)+strlen(GetPath())+1);
	    strcpy(text2,GetPath());
	    strcat(text2,itemarray[i]->filename);
	    SetPositionToText(&pos,oldx[i],oldy[i],' ');
	    SendFileInfoToDesktop(text2,pos,NULL,NULL);
	    free(pos);
	    free(text2);
	  }
	  maxheight=sy;
	}
	x=savex;
	y=savey+maxheight-sy;
	savex=savex+sx+10;
	itemarray[anzahlarray-1]=direntry;
	oldx[anzahlarray-1]=x;
	oldy[anzahlarray-1]=y;
      }
    } else if (GetKindOfWindow()==DETAIL){
      savex=20;
      savey=savey+sy;
      x=savex;
      y=savey;
    } else {
      savex=22;
      for (i=0;i<strlen(direntry->filename);i++) {
	if (direntry->filename[i]=='/') 
	  savex=savex+15;
      }
      savey=savey+sy+2;
      x=savex;
      y=savey;
    }
    if (GetKindOfWindow()==NORMAL) {
      SetPositionToText(&pos,x,y,' ');
      SendFileInfoToDesktop(text,pos,NULL,NULL);
      free(pos);
    } 
    XMoveWindow(GetDisplay(),direntry->Iconwindow,x,y);
  }
  free(a);free(b);free(c);
  free(text);
}  
  
void MakeWindowIcons()
{
  struct item *direntry;
  directory=GetDirectory(GetPath());
  SortIcons(0);
  direntry=directory;
  while (direntry!=NULL) {
    CreateIconWithDirentry(direntry,True,False);
    direntry=direntry->NextItem;
  }
  CalcMoveWindowSize();
}

Window LowerIcons()
{
  struct item *direntry;
  Window last;
  XWindowChanges wc;
  unsigned int changemask;
  direntry=directory;
  last=GetWindow();
  while (direntry!=NULL) {
    wc.sibling=last;
    wc.stack_mode=Above;
    changemask=CWStackMode|CWSibling;
    XConfigureWindow(GetDisplay(),direntry->Iconwindow,changemask,&wc);
    last=direntry->Iconwindow;
    direntry=direntry->NextItem;
  }
  return(last);
}

void CreateExpandButton(struct tree *drawtree)
{
    drawtree->Expandbutton=XCreateSimpleWindow(GetDisplay(),GetMoveWindow(),
				  1,1,1,1,0,
				  0,
				  GetBestColor(0,0,0)
				  );
    XSelectInput(GetDisplay(),drawtree->Expandbutton,ButtonReleaseMask|ButtonPressMask|PointerMotionMask);
    drawtree->Expandline=XCreateSimpleWindow(GetDisplay(),GetMoveWindow(),
				  1,1,1,1,0,
				  0,
				  GetBestColor(0,0,0)
				  );
}

void ArrangeButtons(struct tree *drawtree)
{
  int x,y;
  int xt,yt,ye;
  unsigned int width,height,height2;
  unsigned int border,depth;
  Window root;
  struct tree *linetree;

  if (drawtree!=NULL && drawtree->initalized==True) {
    XGetGeometry(GetDisplay(),drawtree->ThisItem->Iconwindow,&root,&x,&y,
		 &width,&height,&border,&depth);
    if (drawtree->abletoexpand==False) {
      XMoveResizeWindow(GetDisplay(),drawtree->Expandbutton,
			x-22,y+(1+height)/2,22,1);
      XSetWindowBackground(GetDisplay(),drawtree->Expandbutton,GetBestColor(0,0,0));
      XMapRaised(GetDisplay(),drawtree->Expandbutton);
      XUnmapWindow(GetDisplay(),drawtree->Expandline);
    } else if (drawtree->expanded==True) {
      XMoveResizeWindow(GetDisplay(),drawtree->Expandbutton,
			x-22,y+(height-15)/2,22,15);
      XMapRaised(GetDisplay(),drawtree->Expandbutton);
      linetree=drawtree->subtree;
      ye=0;
      while(linetree!=NULL) {
	XGetGeometry(GetDisplay(),linetree->ThisItem->Iconwindow,&root,&xt,&yt,
		     &width,&height2,&border,&depth);
	if (yt>ye) ye=yt;
	linetree=linetree->nexttree;
      }
      XMoveResizeWindow(GetDisplay(),drawtree->Expandline,
			x-8,y+14+(height-15)/2,1,ye-y-5);	
      XMapRaised(GetDisplay(),drawtree->Expandline);
      ArrangeButtons(drawtree->subtree);
    } else {
      XMoveResizeWindow(GetDisplay(),drawtree->Expandbutton,
			x-22,y+(height-15)/2,22,15);
      XMapRaised(GetDisplay(),drawtree->Expandbutton);
      XUnmapWindow(GetDisplay(),drawtree->Expandline);
    }
    ArrangeButtons(drawtree->nexttree);    
  }
}

struct tree *DeleteTreeRec(struct tree *deltree)
{
  struct tree *treeentry;
  treeentry=deltree->subtree;
  while (treeentry!=NULL) {
    treeentry=DeleteTreeRec(treeentry);
  }
  treeentry=deltree->nexttree;
  if (deltree->initalized==True) {
    XDestroyWindow(GetDisplay(),deltree->ThisItem->Iconwindow);
    XDestroyWindow(GetDisplay(),deltree->Expandbutton);
    XDestroyWindow(GetDisplay(),deltree->Expandline);
  }
  free(deltree->ThisItem->filename);
  free(deltree->ThisItem);
  free(deltree);
  return(treeentry);
}

void DeleteTree(struct tree *deltree)
{
  struct tree *treeentry;
  if (closed==0) {
    DataPixmap(treeplus_xpm,&closed,&closed_shape);
    DataPixmap(treeminus_xpm,&opened,&opened_shape);
  }
  XSetWindowBackgroundPixmap(GetDisplay(),deltree->Expandbutton,closed);
  XShapeCombineMask(GetDisplay(),deltree->Expandbutton, ShapeBounding, 0, 0, 
		    closed_shape, ShapeSet);
  XClearWindow(GetDisplay(),deltree->Expandbutton);
  Freeze(True);
  treeentry=deltree->subtree;
  while (treeentry!=NULL && treeentry->initalized==True) {
    deltree->ThisItem->NextItem=treeentry->ThisItem->NextItem;
    if (treeentry->nexttree==NULL)
      treeentry=treeentry->subtree;
    else
      treeentry=treeentry->nexttree;
  }
  treeentry=deltree->subtree;
  while (treeentry!=NULL) {
    treeentry=DeleteTreeRec(treeentry);
  }
  DoTree(deltree);
  ArrangeIcons();
  ArrangeButtons(toptree);
  Freeze(False);
}

void ExpandTree(struct tree *exptree)
{
  struct tree *treeentry;
  struct item *saveitem;
  struct item *lastitem=NULL;
  int i=0;
  int x,y;
  unsigned int width,height;
  unsigned int border,depth;
  Window root;

  if (closed==0) {
    DataPixmap(treeplus_xpm,&closed,&closed_shape);
    DataPixmap(treeminus_xpm,&opened,&opened_shape);
  }
  XSetWindowBackgroundPixmap(GetDisplay(),exptree->Expandbutton,opened);
  XShapeCombineMask(GetDisplay(),exptree->Expandbutton, ShapeBounding, 0, 0, 
		    opened_shape, ShapeSet);
  XClearWindow(GetDisplay(),exptree->Expandbutton);
  Freeze(True);
  treeentry=exptree->subtree;
  saveitem=exptree->ThisItem->NextItem;  
  while (treeentry!=NULL) {
    CreateIconWithDirentry(treeentry->ThisItem,True,False);
    if (i==0) {
      i++;
      exptree->ThisItem->NextItem=treeentry->ThisItem;
      lastitem=treeentry->ThisItem;
    } else {
      lastitem->NextItem=treeentry->ThisItem;
      lastitem=treeentry->ThisItem;
    }
    treeentry=treeentry->nexttree;
  }
  lastitem->NextItem=saveitem;
  exptree->expanded=True;
  ArrangeIcons();
  ArrangeButtons(toptree);
  if (moveony==True)
    XRaiseWindow(GetDisplay(),moveymain);
  if (moveonx==True)
    XRaiseWindow(GetDisplay(),movexmain);
  Freeze(False);
  XFlush(GetDisplay());
  treeentry=exptree->subtree;
  while (treeentry!=NULL) {
    DoTree(treeentry);
    CreateExpandButton(treeentry);
    XGetGeometry(GetDisplay(),treeentry->ThisItem->Iconwindow,&root,&x,&y,
		 &width,&height,&border,&depth);
    if (treeentry->abletoexpand==True) {
      XSetWindowBackgroundPixmap(GetDisplay(),treeentry->Expandbutton,closed);
      XShapeCombineMask(GetDisplay(),treeentry->Expandbutton, ShapeBounding, 0, 0, 
			closed_shape, ShapeSet);
      XMoveResizeWindow(GetDisplay(),treeentry->Expandbutton,
			x-22,y+(height-15)/2,22,15);
      XMapRaised(GetDisplay(),treeentry->Expandbutton);
    } else {
      XMoveResizeWindow(GetDisplay(),treeentry->Expandbutton,
			x-22,y+(1+height)/2,22,1);
      XSetWindowBackground(GetDisplay(),treeentry->Expandbutton,GetBestColor(0,0,0));
      XMapRaised(GetDisplay(),treeentry->Expandbutton);
    }
    treeentry=treeentry->nexttree;
  }
}

void MakeWindowTree()
{
  toptree=GetFirstTree();
  directory=toptree->ThisItem;
  CreateIconWithDirentry(directory,True,False);
  CreateExpandButton(toptree);
  if (toptree->abletoexpand==True) 
    ExpandTree(toptree);
  CalcMoveWindowSize();
}

struct item *GetDirentryFromWindow(Window win)
{
  struct item *direntry;
  direntry=directory;
  while (direntry!=NULL && direntry->Iconwindow!=win)
    direntry=direntry->NextItem;
  return(direntry);
}

struct tree *GetTreeentryFromWindow(struct tree *pushtree,Window win)
{
  struct tree *dummytree;
  if (pushtree!=NULL && pushtree->initalized==True) {
    if (pushtree->Expandbutton==win)
      return(pushtree);
    else {
      if (pushtree->expanded==True) {
	dummytree=GetTreeentryFromWindow(pushtree->subtree,win);
	if (dummytree!=NULL)
	  return(dummytree);
      }
      return(GetTreeentryFromWindow(pushtree->nexttree,win));
    }
  } else
    return(NULL);
}
  
void SaveNewWindowPosition()
{
  char *pos1;
  char *pos2;
  char *pos3;
  char *dummy1,*dummy2;
  XWindowAttributes rootatr;
  int x1,y1;
  unsigned int width1,height1;
  int x=0,y=0;
  unsigned int width=0,height=0;
  unsigned int border,depth;
  Window root;
  XEvent ev;
  do {
    if (XEventsQueued(GetDisplay(),QueuedAfterReading)>0) {
      XPeekEvent(GetDisplay(),&ev);
      if (ev.type==ConfigureNotify || ev.type==NoExpose)
        XNextEvent(GetDisplay(),&ev);
    }
  } while(XEventsQueued(GetDisplay(),QueuedAfterReading)>0 && (ev.type==ConfigureNotify || ev.type==NoExpose));
  do {
    XSync(GetDisplay(),False);
    x1=x;y1=y;width1=width;height1=height;
    XGetGeometry(GetDisplay(),GetGreatestParent(GetWindow()),
    	         &root,&x,&y,&width,&height,&border,&depth);
  } while (x!=x1 || y!=y1 || width!=width1 || height!=height1);
  XGetGeometry(GetDisplay(),GetWindow(),
	       &root,&x,&y,&width,&height,&border,&depth);
  XTranslateCoordinates(GetDisplay(),GetWindow(),XDefaultRootWindow(GetDisplay()),
			0,0,&x,&y,&root);
  XGetWindowAttributes(GetDisplay(),GetWindow(),&rootatr);
  if (rootatr.map_state!=IsUnmapped) {
    GetFileInfoFromDesktop(GetWindowName(),&pos3,&dummy1,&dummy2);
    if (pos3==NULL)
      SetPositionToText(&pos1,x,y,' ');
    else
      SetPositionToText(&pos1,x,y,pos3[0]);
    SetPositionToText(&pos2,width,height,' ');
    SendFileInfoToDesktop(GetWindowName(),pos1,NULL,pos2);
    free(pos1);
    free(pos2);
    free(pos3);
    free(dummy1);
    free(dummy2);
    CalcMoveWindowSize();
  }
}

Window GetGreatestParent(Window w)
{
  Window last;
  Window this;
  Window root;
  Status status;
  Window *children;
  unsigned int nchildren;
  this=w;
  do {
    last=this;
    status=XQueryTree(GetDisplay(),last,&root,&this,&children,&nchildren);
    if (status) XFree(children);
  } while (this!=root);
  return(last);
}

void UnsetMarks()
{
  struct item *direntry;
  direntry=directory;
  while (direntry!=NULL) {
    if (direntry->mark==True) {
      direntry->mark=False;
      CreateIconWithDirentry(direntry,False,False);
    }
    direntry=direntry->NextItem;
  }
}

void SetAllMarks()
{
  struct item *direntry;
  if (GetKindOfWindow()!=STRUCTURE) {
  direntry=directory;
  while (direntry!=NULL) {
    if (direntry->mark==False) {
      direntry->mark=True;
      CreateIconWithDirentry(direntry,False,False);
    }
    direntry=direntry->NextItem;
  }
  }
}

void RubberBand(int x,int y)
{
  struct item *direntry;
  int iconx,icony;
  unsigned int width,height;
  int movewinposx,movewinposy;
  unsigned int border,depth;
  Window root;
  XEvent event;
  int sx=x,sy=y;
  int x1,y1,sx1,sy1;
  GC gc;
  Pixmap pixmap;
  int buttonup=0;
  Window x1y1x2y1,x1y1x1y2,x1y2x2y2,x2y1x2y2;
  XSetWindowAttributes xswa;
  unsigned long valuemask;
  Window last;
  XWindowChanges wc;
  unsigned int changemask;
  if (GetIsDesktop()==True) {
    XGetGeometry(GetDisplay(),XDefaultRootWindow(GetDisplay()),&root,
		 &movewinposx,&movewinposy,&width,&height,&border,&depth);
    gc=XCreateGC(GetDisplay(),XDefaultRootWindow(GetDisplay()),0,0);
    pixmap=XCreatePixmap(GetDisplay(),XDefaultRootWindow(GetDisplay()),8,8,depth);  
    XGetGeometry(GetDisplay(),GetMoveWindow(),&root,
		 &movewinposx,&movewinposy,&width,&height,&border,&depth);
    XGetGeometry(GetDisplay(),GetWindow(),&root,
		 &iconx,&icony,&width,&height,&border,&depth);
  } else {
  XGetGeometry(GetDisplay(),GetMoveWindow(),&root,
	       &movewinposx,&movewinposy,&width,&height,&border,&depth);
  XGetGeometry(GetDisplay(),GetWindow(),&root,
	       &iconx,&icony,&width,&height,&border,&depth);
  gc=XCreateGC(GetDisplay(),GetMoveWindow(),0,0);
  pixmap=XCreatePixmap(GetDisplay(),GetMoveWindow(),8,8,depth);  
  }
  XSetBackground(GetDisplay(),gc,GetBestColor(65535,65535,65535));
  XSetForeground(GetDisplay(),gc,GetBestColor(65535,65535,65535));

  XFillRectangle(GetDisplay(),pixmap,gc,0,0,8,8);
  XSetForeground(GetDisplay(),gc,GetBestColor(0,0,0));
  XDrawRectangle(GetDisplay(),pixmap,gc,0,0,4,4);
  XDrawRectangle(GetDisplay(),pixmap,gc,4,4,4,4);
  if (GetIsDesktop()==True) {
    xswa.override_redirect=True;
    xswa.event_mask=ButtonReleaseMask|ButtonPressMask|PointerMotionMask;
    valuemask=CWOverrideRedirect|CWEventMask;
    x1y1x2y1=XCreateWindow(GetDisplay(),XDefaultRootWindow(GetDisplay()),0,0,1,1,
		      0,CopyFromParent,InputOutput,CopyFromParent,valuemask,&xswa);
    x1y1x1y2=XCreateWindow(GetDisplay(),XDefaultRootWindow(GetDisplay()),0,0,1,1,
		      0,CopyFromParent,InputOutput,CopyFromParent,valuemask,&xswa);
    x1y2x2y2=XCreateWindow(GetDisplay(),XDefaultRootWindow(GetDisplay()),0,0,1,1,
		      0,CopyFromParent,InputOutput,CopyFromParent,valuemask,&xswa);
    x2y1x2y2=XCreateWindow(GetDisplay(),XDefaultRootWindow(GetDisplay()),0,0,1,1,
		      0,CopyFromParent,InputOutput,CopyFromParent,valuemask,&xswa);
   } else {
    x1y1x2y1=XCreateSimpleWindow(GetDisplay(),GetMoveWindow(),0,0,1,1,0,0,0);
    x1y1x1y2=XCreateSimpleWindow(GetDisplay(),GetMoveWindow(),0,0,1,1,0,0,0);
    x1y2x2y2=XCreateSimpleWindow(GetDisplay(),GetMoveWindow(),0,0,1,1,0,0,0);
    x2y1x2y2=XCreateSimpleWindow(GetDisplay(),GetMoveWindow(),0,0,1,1,0,0,0);
  }
  XSetWindowBackgroundPixmap(GetDisplay(),x1y1x2y1,pixmap);
  XSetWindowBackgroundPixmap(GetDisplay(),x1y1x1y2,pixmap);
  XSetWindowBackgroundPixmap(GetDisplay(),x1y2x2y2,pixmap);
  XSetWindowBackgroundPixmap(GetDisplay(),x2y1x2y2,pixmap);
  XMapRaised(GetDisplay(),x1y1x2y1);
  XMapRaised(GetDisplay(),x1y1x1y2);
  XMapRaised(GetDisplay(),x2y1x2y2);
  XMapRaised(GetDisplay(),x1y2x2y2);
  if (GetIsDesktop()==True) {
    XLowerWindow(GetDisplay(),GetWindow()); 
    LowerIcons();
    last=GetWindow();
    direntry=directory;
    while (direntry!=NULL) {
      last=direntry->Iconwindow;
      direntry=direntry->NextItem;
    }
    wc.sibling=last;
    wc.stack_mode=Above;
    changemask=CWStackMode|CWSibling;
    XConfigureWindow(GetDisplay(),x1y1x2y1,changemask,&wc);
    XConfigureWindow(GetDisplay(),x1y1x1y2,changemask,&wc);
    XConfigureWindow(GetDisplay(),x2y1x2y2,changemask,&wc);
    XConfigureWindow(GetDisplay(),x1y2x2y2,changemask,&wc);
  }
  do {
    if (x<sx) { x1=x; sx1=sx;} else { x1=sx; sx1=x;}
    if (y<sy) { y1=y; sy1=sy;} else { y1=sy; sy1=y;}
    XMoveResizeWindow(GetDisplay(),x1y1x2y1,x1,y1,sx1-x1+1,1);
    XMoveResizeWindow(GetDisplay(),x1y1x1y2,x1,y1,1,sy1-y1+1);
    XMoveResizeWindow(GetDisplay(),x2y1x2y2,sx1,y1,1,sy1-y1+1);
    XMoveResizeWindow(GetDisplay(),x1y2x2y2,x1,sy1,sx1-x1+1,1);
    XNextEvent(GetDisplay(),&event);
    while(XEventsQueued(GetDisplay(),QueuedAfterReading)>5 && event.type==MotionNotify)
      XNextEvent(GetDisplay(),&event);
    switch (event.type) {
    case MotionNotify:
      sx=event.xmotion.x;
      sy=event.xmotion.y;
      if (sx < -movewinposx) sx= -movewinposx;
      if (sy < -movewinposy) sy= -movewinposy;
      if (moveony==True) {
	if (sx > -movewinposx+width-15) 
	  sx= -movewinposx+width-15;
      } else {
	if (sx > -movewinposx+width-1) 
	  sx= -movewinposx+width-1;
      }
      if (moveonx==True) {
	if (sy > -movewinposy+height-15) 
	  sy= -movewinposy+height-15;
      } else {
	if (sy > -movewinposy+height-1) 
	  sy= -movewinposy+height-1;
      }
     break;
    case ButtonRelease:
      buttonup=1;
      break;
    }
  } while (buttonup==0);
  XFreeGC(GetDisplay(),gc);
  XDestroyWindow(GetDisplay(),x1y1x2y1);
  XDestroyWindow(GetDisplay(),x1y1x1y2);
  XDestroyWindow(GetDisplay(),x2y1x2y2);
  XDestroyWindow(GetDisplay(),x1y2x2y2);
  XFreePixmap(GetDisplay(),pixmap);
  if (sx<x){
    border=x;
    x=sx;
    sx=border;
  }
  if (sy<y){
    border=y;
    y=sy;
    sy=border;
  }
  if (GetKindOfWindow()!=STRUCTURE) {
    direntry=directory;
    while (direntry!=NULL) {
      XGetGeometry(GetDisplay(),direntry->Iconwindow,&root,
		   &iconx,&icony,&width,&height,&border,&depth);
      if ((int)(sx-iconx)>=0 &&
	  (int)(iconx+width-x)>=0 && 
	  (int)(sy-icony)>=0 && 
	  (int)(icony+height-y)>=0 ) {
	direntry->mark=True;
	CreateIconWithDirentry(direntry,False,False);
      }
      direntry=direntry->NextItem;
    }
  }
}

int GetMarkedNumber()
{
  struct item *direntry;
  int number=0;
  direntry=directory;
  while (direntry!=NULL) {
    if (direntry->mark==True) {
      number++;
    }
    direntry=direntry->NextItem;
  }
  return number;
}

void GetMarkedNames(char** files)
{
  struct item *direntry;
  char *text;
  char *text2;
  char *text3;
  direntry=directory;
  *files=malloc(1);
  (*files)[0]=0;
  while (direntry!=NULL) {
    if (direntry->mark==True) {
      text2=malloc(strlen(direntry->filename)+strlen(GetPath())+1);
      strcpy(text2,GetPath());
      strcat(text2,direntry->filename);
      text3=GenerateSlashName(text2);
      text=malloc(strlen(*files)+strlen(text3)+2);
      strcpy(text,*files);
      strcat(text," ");
      strcat(text,text3);
      free(text3);
      free(text2);
      free(*files);
      *files=text;
    }
    direntry=direntry->NextItem;
  }
}

void IconMotion(struct item *direntry,int x,int y,int rootx,int rooty)
{
  struct item *direntry2;
  char *newpos;
  char *pos;
  char *icon;
  char *start;
  char *text;
  char *files;
  Window NeuesIcon;
  Window other;
  XEvent event;
  int ondesk;
  int xw,yw;
  int xr,yr;
  int buttonup=0;
  unsigned int keys;
  XWindowAttributes attr;

  NeuesIcon=direntry->Iconwindow;
  direntry->mark=False;
  if (GetMarkedNumber()>0)
    CreateIconWithDirentry(direntry,True,True);
  else
    CreateIconWithDirentry(direntry,True,False);
  direntry->mark=True;
  other=direntry->Iconwindow;
  direntry->Iconwindow=NeuesIcon;
  NeuesIcon=other;
  XReparentWindow(GetDisplay(),NeuesIcon,XDefaultRootWindow(GetDisplay()),
		  rootx-x,rooty-y);
  do {
    XNextEvent(GetDisplay(),&event);
    while(XEventsQueued(GetDisplay(),QueuedAfterReading)>5 && event.type==MotionNotify)
      XNextEvent(GetDisplay(),&event);
    switch (event.type) {
    case MotionNotify:
      XMoveWindow(GetDisplay(),NeuesIcon,
		  event.xmotion.x_root-x,event.xmotion.y_root-y);
      break;
    case ButtonRelease:
      buttonup=1;
      break;
    }
  } while (buttonup==0);
  XDestroyWindow(GetDisplay(),NeuesIcon);
  XFlush(GetDisplay());
  XQueryPointer(GetDisplay(),XDefaultRootWindow(GetDisplay()),&other,
		&NeuesIcon,&xr,&yr,&xw,&yw,&keys);
  ondesk=False;
  if (GetIsDesktop()==True) {
    direntry2=directory;
    while (direntry2!=NULL) {
      if (direntry2->Iconwindow==NeuesIcon)
	ondesk=True;
      direntry2=direntry2->NextItem;
    }
  }
  if (NeuesIcon==GetGreatestParent(GetWindow()) || ondesk==True) {
    if (GetIsDesktop()==False || ondesk==False) 
      XQueryPointer(GetDisplay(),GetMoveWindow(),&other,&NeuesIcon,
		    &xr,&yr,&xw,&yw,&keys);
    if (NeuesIcon==None) {
      if (GetKindOfWindow()==NORMAL) {
	text=malloc(strlen(direntry->filename)+strlen(GetPath())+1);
	strcpy(text,GetPath());
	strcat(text,direntry->filename);
	GetFileInfoFromDesktop(text,&pos,&icon,&start);
	if (pos==NULL || pos[0]!='a') {
	  if (GetIsDesktop()==True && grid>0) {
	    XGetWindowAttributes(GetDisplay(),direntry->Iconwindow,&attr);
	    xr=(int)(0.5+(double)(xw-x+attr.width/2)/(double)grid)*grid;
	    yr=(int)(0.5+(double)(yw-y+attr.height/2)/(double)grid)*grid;
	    SetPositionToText(&newpos,xr-attr.width/2,yr-attr.height/2,' ');
	    SendFileInfoToDesktop(text,newpos,NULL,NULL);
	    free(newpos);
	    XMoveWindow(GetDisplay(),direntry->Iconwindow,
			xr-attr.width/2,yr-attr.height/2);	    
	  } else {
	    SetPositionToText(&newpos,xw-x,yw-y,' ');
	    SendFileInfoToDesktop(text,newpos,NULL,NULL);
	    free(newpos);
	    XMoveWindow(GetDisplay(),direntry->Iconwindow,
			xw-x,yw-y);
	  }
	}
	free(pos);
	free(icon);
	free(start);
	free(text);
      }
    } else 
      if (NeuesIcon!=direntry->Iconwindow) {
	direntry2=GetDirentryFromWindow(NeuesIcon);
	if (direntry2!=NULL) {
	  if (direntry2->filename[strlen(direntry2->filename)-1]!='/') {
	    text=malloc(strlen(direntry2->filename)+strlen(GetPath())+1);
	    strcpy(text,GetPath());
	    strcat(text,direntry2->filename);
	    GetFileInfoFromDesktop(text,&pos,&icon,&start);
	    if (start==NULL || icon==NULL) {
	      free(icon);
	      free(start);
	      GetExtensionParameter(direntry2->filename,text,&icon,&start);
	    }
	    GetMarkedNames(&files);
	    ExecuteShellWithFollowLink(text,start,files,0);
	    free(files);
	    free(text);
	    free(pos);
	    free(icon);
	    free(start);
	  } else {
	    GetMarkedNames(&files);	    
	    GoalWasFolder(GetMoveWindow(),direntry2->filename,files,keys);
	    free(files);
	  }
	}
      }
  } else {
    GetMarkedNames(&files);
    if (GetKindOfWindow()==NORMAL)
      SendFiles(x,y,files);
    else
      SendFiles(0,0,files);      
    free(files);
  }
  CalcMoveWindowSize();
}

void NewIcon(char *filename,char *orginal,int x,int y,int iconnr)
{
  char *pos;
  char *icon;
  char *start;
  char *text,*text2,*text3;
  struct item *direntry;
  struct item *new;
  int i=1,j=1;
  anzahlarray=0;
  if (iconnr==1) {
    savex=x;
    savey=y;
    maxheight=0;
  }
  do {
    j++;
    if (filename[j-2]=='/')
      i=j-1;
  } while (filename[j]!=0);
  text=malloc(j-i+1);
  strncpy(text,filename+i,j-i);
  text[j-i]=0;
  GetFileInfoFromDesktop(orginal,&pos,&icon,&start);
  if (start==NULL || icon==NULL) {
    free(icon);
    free(start);
    GetExtensionParameter(text,filename,&icon,&start);
  }
  text2=malloc(strlen(text)+strlen(GetPath())+1);
  strcpy(text2,GetPath());
  strcat(text2,text);
  EraseFileInfoInDesktop(text2);
  SendFileInfoToDesktop(text2,NULL,icon,start);
  direntry=directory;
  if (direntry==NULL) {
    directory=malloc(sizeof(struct item));
    new=directory;
  } else {
    while (direntry->NextItem!=NULL)
      direntry=direntry->NextItem;
    new=malloc(sizeof(struct item));
    direntry->NextItem=new;
  }
  new->filename=malloc(strlen(text)+1);
  strcpy(new->filename,text);
  if (strncmp(text2,"~/",strlen("~/"))==0) {
    text3=malloc(strlen((char*)getenv("HOME"))+strlen(text2)+1);
    strcpy(text3,(char*)getenv("HOME"));
    strcat(text3,text2+1);
    free(text2);
    text2=malloc(strlen(text3)+1);
    strcpy(text2,text3);
    free(text3);
  }
  stat(text2,&(new->info));
  new->type=0;
  if ((new->info.st_mode & 16384) == 16384) {
    text2[strlen(text2)-1]=0;
    new->type++;
  }
  lstat(text2,&(new->info));
  new->mark=False;
  if ((new->info.st_mode & 8192) == 8192)
    new->type=new->type+2;
  new->NextItem=NULL;
  CreateIconWithDirentry(new,True,False);    
  free(text2);
  free(pos);
  free(icon);
  free(start);
  free(text);
  if (GetKindOfWindow()==DETAIL) {
    SortIcons(sorttype);
    ArrangeIcons();
  }
  CalcMoveWindowSize();
}

void ArrangeIcons()
{
  int x,y;
  unsigned int width,height;
  unsigned int border,depth;
  Window root;
  struct item *direntry;
  XGetGeometry(GetDisplay(),GetWindow(),&root,&x,&y,
	       &width,&height,&border,&depth);
  if (GetKindOfWindow()==NORMAL)
    XMoveResizeWindow(GetDisplay(),GetMoveWindow(),0,0,width,height);
  ResetPosition();
  direntry=directory;
  while (direntry!=NULL) {
    XGetGeometry(GetDisplay(),direntry->Iconwindow,&root,&x,&y,
		 &width,&height,&border,&depth);
    SetBestPosition(direntry,width,height);
    direntry=direntry->NextItem;
  }
  CalcMoveWindowSize();
}

void EraseIcon(char *filename)
{
  struct item *direntry;
  struct item *last;
  char *text;
  char *text2;
  int i=1,j=1;
  anzahlarray=0;
  text=malloc(strlen(filename)+2);
  strcpy(text,filename);
  if (text[strlen(text)-1]=='/')
    text[strlen(text)-1]=0;
  else
    strcat(text,"/");
  EraseFileInfoInDesktop(text);
  EraseFileInfoInDesktop(filename);
  free(text);
  do {
    j++;
    if (filename[j-2]=='/')
      i=j-1;
  } while (filename[j]!=0);
  text=malloc(j-i+1);
  strncpy(text,filename+i,j-i);
  text[j-i]=0;
  text2=malloc(strlen(text)+2);
  strcpy(text2,text);
  if (text2[strlen(text2)-1]=='/')
    text2[strlen(text2)-1]=0;
  else
    strcat(text2,"/");
  direntry=directory;
  if (direntry!=NULL)
    if (strcmp(direntry->filename,text)==0 ||
	strcmp(direntry->filename,text2)==0) {
      directory=direntry->NextItem;
      free(direntry->filename);
      XDestroyWindow(GetDisplay(),direntry->Iconwindow);
      free(direntry);
    } else {
      do {
	last=direntry;
	direntry=direntry->NextItem;
      } while (direntry!=NULL &&
	       strcmp(direntry->filename,text)!=0 &&
	       strcmp(direntry->filename,text2)!=0);
      if (direntry!=NULL) {
	last->NextItem=direntry->NextItem;
	free(direntry->filename);
	XDestroyWindow(GetDisplay(),direntry->Iconwindow);
	free(direntry);
      }
    }
  free(text);
  free(text2);
  if (GetKindOfWindow()==DETAIL) {
    SortIcons(sorttype);
    ArrangeIcons();
  }
  CalcMoveWindowSize();
}

void MoveTheMoveWindow(XEvent evnt)
{
  int z;
  int goalx,goaly;
  int xw,yw;
  int xr,yr;
  int buttonup=0;
  unsigned int keys;
  Window child;
  int x,y;
  unsigned int width,height;
  int ax,ay;
  unsigned int nwidth,nheight;
  unsigned int minx,miny;
  unsigned int border,depth;
  Window root;
    XGetGeometry(GetDisplay(),GetWindow(),&root,&x,&y,
		 &width,&height,&border,&depth);
    if (moveony==True) width=width-14;
    if (moveonx==True) height=height-14;
    XGetGeometry(GetDisplay(),GetMoveWindow(),&root,&ax,&ay,
		 &minx,&miny,&border,&depth);
    XQueryPointer(GetDisplay(),GetMoveWindow(),&root,&child,
		  &xr,&yr,&xw,&yw,&keys);
  if (evnt.xbutton.button==2) {
    do {
      XNextEvent(GetDisplay(),&evnt);
     while(XEventsQueued(GetDisplay(),QueuedAfterReading)>5 && evnt.type==MotionNotify)
      XNextEvent(GetDisplay(),&evnt);
     switch (evnt.type) {
      case MotionNotify:
	goalx=evnt.xmotion.x_root-xr+ax;
	goaly=evnt.xmotion.y_root-yr+ay;
	if (goalx>0) goalx=0;
	if (goaly>0) goaly=0;
	if (goalx<(int)width-(int)minx) goalx=(int)width-(int)minx;
	if (goaly<(int)height-(int)miny) goaly=(int)height-(int)miny;
	XMoveWindow(GetDisplay(),GetMoveWindow(),goalx,goaly);
	if (GetKindOfWindow()==DETAIL)
	  XMoveWindow(GetDisplay(),GetDetailWindow(),20+goalx,0);
	/*          */
	if (moveony==True) {
	  XMoveResizeWindow(GetDisplay(),movey,2,
	      2+(int)((double)(height-4)*(double)(-goaly)/(double)miny),
	      10,
	      1+(int)((double)(height-4)*(double)height/(double)miny)
			    );
	}
	if (moveonx==True) {
	  XMoveResizeWindow(GetDisplay(),movex,
	      2+(int)((double)(width-4)*(double)(-goalx)/(double)minx),
	      2,
	      1+(int)((double)(width-4)*(double)width/(double)minx),
	      10
			    );
	}
	/*         */

	break;
      case ButtonRelease:
	buttonup=1;
	break;
      }
    } while (buttonup==0);
  } else if (evnt.xbutton.window==movex || evnt.xbutton.window==movexmain) {
    XGetGeometry(GetDisplay(),movex,&root,&x,&y,
		 &nwidth,&nheight,&border,&depth);
    do {
      XNextEvent(GetDisplay(),&evnt);
     while(XEventsQueued(GetDisplay(),QueuedAfterReading)>5 && evnt.type==MotionNotify)
      XNextEvent(GetDisplay(),&evnt);
      switch (evnt.type) {
      case MotionNotify:
	goalx=evnt.xmotion.x_root-xr+x;
	if (goalx<2) goalx=2;
	z=(int)(-0.5-(double)(goalx-2)*(double)minx/(double)(width-4));
	if (goalx>width-nwidth-2) {
	  goalx=width-nwidth-2;
	  z=width-minx;
	}
	XMoveWindow(GetDisplay(),movex,goalx,2);
	XMoveWindow(GetDisplay(),GetMoveWindow(),z,ay);
	if (GetKindOfWindow()==DETAIL)
	  XMoveWindow(GetDisplay(),GetDetailWindow(),20+z,0);
	break;
      case ButtonRelease:
	buttonup=1;
	break;
      }
    } while (buttonup==0);
  } else if (evnt.xbutton.window==movey || evnt.xbutton.window==moveymain) {
    XGetGeometry(GetDisplay(),movey,&root,&x,&y,
		 &nwidth,&nheight,&border,&depth);
    do {
      XNextEvent(GetDisplay(),&evnt);
     while(XEventsQueued(GetDisplay(),QueuedAfterReading)>5 && evnt.type==MotionNotify)
      XNextEvent(GetDisplay(),&evnt);
      switch (evnt.type) {
      case MotionNotify:
	goaly=evnt.xmotion.y_root-yr+y;
	if (goaly<2) goaly=2;
	z=(int)(-0.5-(double)(goaly-2)*(double)miny/(double)(height-4));
	if (goaly>height-nheight-2) { 
	  goaly=height-nheight-2;
	  z=height-miny;
	}
	XMoveWindow(GetDisplay(),movey,2,goaly);
	XMoveWindow(GetDisplay(),GetMoveWindow(),ax,z);
	if (GetKindOfWindow()==DETAIL)
	  XMoveWindow(GetDisplay(),GetDetailWindow(),20+ax,0);
	break;
      case ButtonRelease:
	buttonup=1;
	break;
      }
    } while (buttonup==0);
  }
  CalcMoveWindowSize();
}

int SortHelp(const void *a,const void *b)
{
  int adot,bdot,i;
  if (sorttype==-1 || sorttype==1)
    return(strcmp(((struct item*)a)->filename,((struct item*)b)->filename));
  else if ((((struct item*)a)->type==0 || ((struct item*)a)->type==2) &&
      (((struct item*)b)->type==1 || ((struct item*)b)->type==3))
    return(1);
  else if ((((struct item*)a)->type==1 || ((struct item*)a)->type==3) &&
	   (((struct item*)b)->type==0 || ((struct item*)b)->type==2))
    return(-1);
  else {     
    adot=strlen(((struct item*)a)->filename)-1;i=0;
    while (((struct item*)a)->filename[i]!=0) {
      if (((struct item*)a)->filename[i]=='.' && i!=0)
	adot=i;
      i++;
    }
    bdot=strlen(((struct item*)b)->filename)-1;i=0;
    while (((struct item*)b)->filename[i]!=0) {
      if (((struct item*)b)->filename[i]=='.' && i!=0)
	bdot=i;
      i++;
    }
    if (sorttype==2 && 
	(strcmp((((struct item*)a)->filename)+adot+1,
		(((struct item*)b)->filename)+bdot+1)<0))
      return(-1);
    else if (sorttype==2 && 	     
	     (strcmp((((struct item*)a)->filename)+adot+1,
		     (((struct item*)b)->filename)+bdot+1)>0))
      return(1);
    else if (sorttype==4 && ((struct item*)a)->info.st_ctime <
	     ((struct item*)b)->info.st_ctime)
      return(-1);
    else if (sorttype==4 && ((struct item*)a)->info.st_ctime >
	     ((struct item*)b)->info.st_ctime)
      return(1);
    else if (sorttype==5 && ((struct item*)a)->info.st_ctime <
	     ((struct item*)b)->info.st_ctime)
      return(1);
    else if (sorttype==5 && ((struct item*)a)->info.st_ctime >
	     ((struct item*)b)->info.st_ctime)
      return(-1);
    else if (sorttype==7 && ((struct item*)a)->info.st_size <
	     ((struct item*)b)->info.st_size)
      return(-1);
    else if (sorttype==7 && ((struct item*)a)->info.st_size >
	     ((struct item*)b)->info.st_size)
      return(1);
    else if (sorttype==8 && ((struct item*)a)->info.st_size <
	     ((struct item*)b)->info.st_size)
      return(1);
    else if (sorttype==8 && ((struct item*)a)->info.st_size >
	     ((struct item*)b)->info.st_size)
      return(-1);
    else return(strcmp(((struct item*)a)->filename,
		       ((struct item*)b)->filename));
  }
}

void SortIcons(int type)
{
  int i,j;
  struct item *direntry;
  struct item *direntry2;
  struct item *direntry3;
  struct item *newdir;
  anzahlarray=0;
  if (GetKindOfWindow()!=STRUCTURE) {
    sorttype=type;
    i=0;
    direntry=directory;
    while (direntry!=NULL) {
      i++;
      direntry=direntry->NextItem;
    }
    if (i>0) {
      newdir=malloc(i*sizeof(struct item));
      i=0;
      direntry=directory;
      while (direntry!=NULL) {
	newdir[i]=*direntry;
	i++;
	direntry=direntry->NextItem;
      }
      qsort(newdir,i,sizeof(struct item),SortHelp);
      direntry2=malloc(sizeof(struct item));
      *direntry2=newdir[0];
      direntry=direntry2;
      for (j=1;j<i;j++) { 
	direntry3=direntry;
	direntry=malloc(sizeof(struct item));
	*direntry=newdir[j];
	direntry3->NextItem=direntry;
      }
      direntry->NextItem=NULL;
      free(newdir);
      newdir=direntry2;
      direntry=directory;
      while (direntry!=NULL) {
	direntry2=direntry->NextItem;
	free(direntry);
	direntry=direntry2;
      }
      directory=newdir;
    }
  }
}

void UpdateWindow()
{
  static char *backgroundnameold=NULL;
  char *backgroundname=NULL;
  char *positiona=NULL;
  char *positions=NULL;
  char *text;
  int r,g,b;
  int sx,sy;
  unsigned long bg;
  Pixmap backgroundpixmap;
  XWindowAttributes rootatr;

  text=GenerateWindowName(GetPath(),NORMAL);
  GetFileInfoFromDesktop(text,&positiona,&backgroundname,&positions);
  if (backgroundname==NULL && GetIsDesktop()==False) {
    backgroundname=GetDefaultBackground();
    /*SendFileInfoToDesktop(text,NULL,backgroundname,NULL);  */
  }
  free(text);
  if (backgroundname!=NULL && (backgroundnameold==NULL || 
			       GetIsDesktop()==True ||
			       strcmp(backgroundnameold,backgroundname)!=0)){
    if (LoadPixmap(backgroundname,&backgroundpixmap,NULL)==0) {
      if (GetIsDesktop()==True) 
	XSetWindowBackgroundPixmap(GetDisplay(),XDefaultRootWindow(GetDisplay()),backgroundpixmap);
      else
	XSetWindowBackgroundPixmap(GetDisplay(),GetMoveWindow(),backgroundpixmap);
      XFreePixmap(GetDisplay(),backgroundpixmap);
    } else {
      bg=GetBestColor(65535,65535,65535);
      if (backgroundname[0]=='#') {
	/*********************************/
	sscanf(backgroundname+2,"%u %u %u",&r,&g,&b);
	bg=GetBestColor(255*r,255*g,255*b);
	/*********************************/
      } 
      if (GetIsDesktop()==True) 
	XSetWindowBackground(GetDisplay(),XDefaultRootWindow(GetDisplay()),bg);	  
      else
	XSetWindowBackground(GetDisplay(),GetMoveWindow(),bg);
    }
    free(backgroundnameold);
    backgroundnameold=malloc(strlen(backgroundname)+1);
    strcpy(backgroundnameold,backgroundname);
    
  }  
  if (GetIsDesktop()==True) {
    GetPositionFromText(positiona,&sx,&sy,&grid);
    XGetWindowAttributes(GetDisplay(),XDefaultRootWindow(GetDisplay()),&rootatr);
    sx=rootatr.width;
    sy=rootatr.height;
    if (positions[0]=='c'){
      sx--;
      sy--;
    } else if (positions[0]=='a')
      sx--;
    else if (positions[0]!='b')
      sy--;
    XMapWindow(GetDisplay(),GetWindow());
    XResizeWindow(GetDisplay(),GetWindow(),sx,sy);
    XResizeWindow(GetDisplay(),GetMoveWindow(),sx,sy);
    XClearWindow(GetDisplay(),XDefaultRootWindow(GetDisplay()));
  } else 
    XClearWindow(GetDisplay(),GetMoveWindow());
  if (positiona!=NULL && positiona[0]=='a')
    SetShowHidden(False);
  else
    SetShowHidden(True);
  free(positiona);
  free(backgroundname);
  free(positions);
}

void UpdateIcons(int fast)
{
  struct item *savedir;
  struct item *olddirentry;
  struct item *newdirentry;
  struct item *eraseentry;
  int resorttype;
  
  StopAlarm();
  UpdateTimer();
  anzahlarray=0;
  if (fast==False) {
    EraseIconPixmaps();
    UpdateWindow();
    UpdateFontName();
  }
  if (GetKindOfWindow()!=STRUCTURE) {
    resorttype=sorttype;
    SortIcons(-1);
    savedir=directory;
    directory=GetDirectory(GetPath());
    SortIcons(-1);
    olddirentry=savedir;
    newdirentry=directory;
    while (newdirentry!=NULL || olddirentry!=NULL) {
      if (newdirentry!=NULL && 
	  olddirentry!=NULL &&
	  strcmp(newdirentry->filename,olddirentry->filename)==0) {
	newdirentry->Iconwindow=olddirentry->Iconwindow;
	if (fast==False)
	  CreateIconWithDirentry(newdirentry,False,False);
	else
	  newdirentry->mark=olddirentry->mark;
	olddirentry=olddirentry->NextItem;
	newdirentry=newdirentry->NextItem;
      }
      if (newdirentry!=NULL && 
	  olddirentry!=NULL &&
	  strcmp(newdirentry->filename,olddirentry->filename)>0) {
	XDestroyWindow(GetDisplay(),olddirentry->Iconwindow);      
	olddirentry=olddirentry->NextItem;
      }
      if (newdirentry!=NULL && 
	  olddirentry!=NULL &&
	  strcmp(newdirentry->filename,olddirentry->filename)<0) {
	CreateIconWithDirentry(newdirentry,True,False);
	newdirentry=newdirentry->NextItem;
      }
      if (newdirentry==NULL && olddirentry!=NULL) {
	XDestroyWindow(GetDisplay(),olddirentry->Iconwindow);      
	olddirentry=olddirentry->NextItem;
      }      
      if (newdirentry!=NULL && olddirentry==NULL) {
	CreateIconWithDirentry(newdirentry,True,False);
	newdirentry=newdirentry->NextItem;
      }      
    }
    while(savedir!=NULL) {
      eraseentry=savedir->NextItem;
      free(savedir->filename);
      free(savedir);
      savedir=eraseentry;
    }
    if (GetKindOfWindow()==DETAIL) {
      SortIcons(resorttype);
      ArrangeIcons();
    }
  } else {
    DeleteTree(toptree);
    ExpandTree(toptree);
  }
  CalcMoveWindowSize();
  ReactivateAlarm();
}

void Markwindow(Window w)
{
  int x,y,x2,y2;
  unsigned int width,height;
  unsigned depth;
  Window root;
  static GC gc;
  static int activ=0;
  unsigned int dummy;
  if (activ==0) {
    gc=XCreateGC(GetDisplay(),XDefaultRootWindow(GetDisplay()),0,0);
    activ++;
  }
  XGetGeometry(GetDisplay(),w,&root,&x,&y,&width,&height,&dummy,&depth);
  if (w==GetMoveWindow()) {
     if (GetIsDesktop()==True) {
       XSetForeground(GetDisplay(),gc,GetBestColor(65535,65535,65535));
       XDrawArc(GetDisplay(),XDefaultRootWindow(GetDisplay()),gc,0,0,width,height,0,360*64);
       XSetForeground(GetDisplay(),gc,GetBestColor(0,0,0));
       XDrawArc(GetDisplay(),XDefaultRootWindow(GetDisplay()),gc,1,1,width,height,0,360*64);
     } else {
       XGetGeometry(GetDisplay(),GetWindow(),&root,&x2,&y2,&width,&height,&dummy,&depth);
       if (moveonx==True) height=height-14;
       if (moveony==True) width=width-14;
       XSetForeground(GetDisplay(),gc,GetBestColor(65535,65535,65535));
       XDrawArc(GetDisplay(),w,gc,-x,-y,width,height,0,360*64);
       XSetForeground(GetDisplay(),gc,GetBestColor(0,0,0));
       XDrawArc(GetDisplay(),w,gc,-x+1,-y+1,width,height,0,360*64);
     }
  } else {
     XSetForeground(GetDisplay(),gc,GetBestColor(65535,65535,65535));
     XDrawArc(GetDisplay(),w,gc,0,0,width,height,0,360*64);
     XSetForeground(GetDisplay(),gc,GetBestColor(0,0,0));
     XDrawArc(GetDisplay(),w,gc,1,1,width,height,0,360*64);
   if (GetIsDesktop()==True) {
     XSetForeground(GetDisplay(),gc,GetBestColor(65535,65535,65535));
     XDrawArc(GetDisplay(),XDefaultRootWindow(GetDisplay()),gc,x,y,width,height,0,360*64);
     XSetForeground(GetDisplay(),gc,GetBestColor(0,0,0));
     XDrawArc(GetDisplay(),XDefaultRootWindow(GetDisplay()),gc,x+1,y+1,width,height,0,360*64);
   } else {
     XSetForeground(GetDisplay(),gc,GetBestColor(65535,65535,65535));
     XDrawArc(GetDisplay(),GetMoveWindow(),gc,x,y,width,height,0,360*64);
     XSetForeground(GetDisplay(),gc,GetBestColor(0,0,0));
     XDrawArc(GetDisplay(),GetMoveWindow(),gc,x+1,y+1,width,height,0,360*64);
   }
  }
}

void Demarkwindow(Window w)
{
  struct item *direntry;
  if (w==GetMoveWindow()) {
    if (GetIsDesktop()==True) 
      XClearWindow(GetDisplay(),XDefaultRootWindow(GetDisplay()));
    else 
      XClearWindow(GetDisplay(),w);
  } else {
    direntry=GetDirentryFromWindow(w);
    if (direntry!=NULL) 
      XClearWindow(GetDisplay(),w);
    if (GetIsDesktop()==True) 
      XClearWindow(GetDisplay(),XDefaultRootWindow(GetDisplay()));
    else
      XClearWindow(GetDisplay(),GetMoveWindow());
  } 
}

int HandleTheEvent(XEvent evnt)
{
  char *pos;
  char *icon;
  char *start;
  char *text;
  char *text2;
  static Time t;
  static int x=0,y=0,press=0;
  struct item *direntry;
  struct tree *treeentry;
  int done=0;
  Window dummy1,dummy2;
  int dummy3,dummy4,dummy5,dummy6;
  unsigned int keys;
  switch (evnt.type) {
  case ConfigureNotify:
    SaveNewWindowPosition();
    break;
  case MotionNotify:
    if (press==1 && evnt.xmotion.window!=GetMoveWindow()) {
      direntry=GetDirentryFromWindow(evnt.xmotion.window);
      if (direntry!=NULL && direntry->mark==True ) {
	if ((x-evnt.xmotion.x_root)*(x-evnt.xmotion.x_root)>4 ||
	    (y-evnt.xmotion.y_root)*(y-evnt.xmotion.y_root)>4) {
	  if (direntry!=directory || GetKindOfWindow()!=STRUCTURE) {
	    IconMotion(direntry,
		       evnt.xmotion.x+x-evnt.xmotion.x_root,
		       evnt.xmotion.y+y-evnt.xmotion.y_root,
		       evnt.xmotion.x_root,evnt.xmotion.y_root);
	  }
	  press=0;
	}
      } else 
	press=0;
    } else 
      if (press==1) {
	RubberBand(evnt.xmotion.x,evnt.xmotion.y);
	press=0;
      }
    break;
  case ButtonRelease:
    press=0;
    break;
  case ButtonPress:
    x=evnt.xbutton.x_root;
    y=evnt.xbutton.y_root;
    if (evnt.xbutton.window==movexmain || 
	evnt.xbutton.window==moveymain ||
	evnt.xbutton.window==movex ||
	evnt.xbutton.window==movey)
      MoveTheMoveWindow(evnt);
    else if (evnt.xbutton.button==3) {
      XDefineCursor(GetDisplay(),GetWindow(),GetWaitCursor());
      if (evnt.xbutton.window==GetMoveWindow()) {
	Markwindow(evnt.xbutton.window);
	text=GenerateSlashName(GetPath());
	MenuLaunch(evnt.xbutton.time,text,True);
	free(text);
	Demarkwindow(evnt.xbutton.window);
      } else {
	direntry=GetDirentryFromWindow(evnt.xbutton.window);
	if (direntry!=NULL) {
	  Markwindow(evnt.xbutton.window);	  
	  if (direntry->mark==True) {
	    GetMarkedNames(&text);
	  } else {
	    text2=malloc(strlen(GetPath())+strlen(direntry->filename)+1);
	    strcpy(text2,GetPath());
	    strcat(text2,direntry->filename); 
	    text=GenerateSlashName(text2);
	    free(text2);
	  }
	  MenuLaunch(evnt.xbutton.time,text,False);
	  Demarkwindow(evnt.xbutton.window);
	  free(text);
	} 
      }
      XDefineCursor(GetDisplay(),GetWindow(),GetNormCursor());
    } else if (evnt.xbutton.button==2)
      MoveTheMoveWindow(evnt);
    else {
      press=1;
      XQueryPointer(GetDisplay(),XDefaultRootWindow(GetDisplay()),
		    &dummy1,&dummy2,&dummy3,&dummy4,&dummy5,&dummy6,&keys);
      /*development*
      if ((keys&ShiftMask)==ShiftMask)
	done=1;
      *************/
      if (evnt.xbutton.window!=GetMoveWindow()) {
	direntry=GetDirentryFromWindow(evnt.xbutton.window);
	if (direntry!=NULL) { 
	  if (direntry->mark==False) {
	    t=evnt.xbutton.time;
	    if ((keys&ControlMask)!=ControlMask || GetKindOfWindow()==STRUCTURE)
	      UnsetMarks();
	    direntry->mark=True;
	    CreateIconWithDirentry(direntry,False,False);
	  } else {
	    if (evnt.xbutton.time-t<500) {
	      XDefineCursor(GetDisplay(),GetWindow(),GetWaitCursor());
	      text=malloc(strlen(direntry->filename)+strlen(GetPath())+1);
	      strcpy(text,GetPath());
	      strcat(text,direntry->filename);
	      GetFileInfoFromDesktop(text,&pos,&icon,&start);
	      if (start==NULL || icon==NULL) {
		free(start);
		free(icon);
		GetExtensionParameter(direntry->filename,text,&icon,&start);
	      }
	      if (GetKindOfWindow()==STRUCTURE && direntry==directory) {
		ExecuteShellcommand(GetPath(),"dfm !0!",NULL,0);
	      } else {
		ExecuteShellWithFollowLink(text,start,NULL,0);
	      }
	      free(text);
	      free(pos);
	      free(icon);
	      free(start);
	      UnsetMarks();
	      XDefineCursor(GetDisplay(),GetWindow(),GetNormCursor());
	    } else
	      t=evnt.xbutton.time;
	  }
	} else {
	  treeentry=GetTreeentryFromWindow(toptree,evnt.xbutton.window);
	  if (treeentry!=NULL) { 
	    if (treeentry->abletoexpand==True) {
	      if (treeentry->expanded==False)
		ExpandTree(treeentry);
	      else
		DeleteTree(treeentry);
	    }
	  }
	  press=0;
	}
      } else
	if ((keys&ControlMask)!=ControlMask)
	  UnsetMarks();
    }
    break;
  default:
    break;
  }
  return(done);
}


